SystemOrganization addCategory: #HarryPotter!
SystemOrganization addCategory: 'HarryPotter-Tests'!

TestCase subclass: #EscuelaTest
	instanceVariableNames: 'harryPotter ron draco gryffindor slytherin hufflepuff ravenclaw hogwarts sombreroSombrerito'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter-Tests'!

EscuelaTest class
	instanceVariableNames: 'sombreroSombrerito'!

!EscuelaTest commentStamp: '<historical>' prior: 0!
An EscuelaTest is a test class for testing the behavior of Escuela!

EscuelaTest class
	instanceVariableNames: 'sombreroSombrerito'!

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/27/2014 15:29'!
setUp

hogwarts := Escuela new.
hogwarts inicializar.

harryPotter := Mago new.
harryPotter poderVarita: 200.
harryPotter colorPelo: 'marron'.
harryPotter inteligencia: 110.
harryPotter sangreSucia: true.
harryPotter inicializarHechizosQueSe.
harryPotter inicializarEnemigos.
harryPotter inicializarLosQueSigo.
harryPotter miPadreEs: 'JuanPotter'.
harryPotter escuela: hogwarts.

ron := Mago new.
ron poderVarita:210.
ron colorPelo: 'rojo'.
ron inteligencia: 90.
ron sangreSucia: false.
ron inicializarHechizosQueSe.
ron inicializarEnemigos.
ron inicializarLosQueSigo.
ron miPadreEs: 'JuanWeasly'.
ron escuela: hogwarts.

draco := Mago new.
draco poderVarita: 80.
draco colorPelo: 'amarillo'.
draco inteligencia: 130.
draco sangreSucia: false.
draco inicializarHechizosQueSe.
draco inicializarEnemigos.
draco inicializarLosQueSigo.
draco miPadreEs: 'JuanMalfoy'.
draco escuela: hogwarts.

gryffindor := Gryffindor new.
gryffindor inicializar.

slytherin := Slytherin new.
slytherin inicializar.

ravenclaw := Ravenclaw new.
ravenclaw inicializar.

hufflepuff := Hufflepuff new. 
hufflepuff inicializar.

sombreroSombrerito := Sombrero new.

hogwarts agregarCasa: gryffindor.
hogwarts agregarCasa: slytherin.
hogwarts agregarCasa: ravenclaw.
hogwarts agregarCasa: hufflepuff.
hogwarts sombreroSeleccionador: sombreroSombrerito.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 16:19'!
testDracoInsultaAHarry

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.

harryPotter esInsultadoPor: draco.

self assert: (harryPotter esEnemigoDe: draco).! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 16:03'!
testHarryQuiereSeguirARonperoNoPuede

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.

self deny: (harryPotter puedoSeguirA: ron).! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:25'!
testPreguntarAlSombreroAQueCasaEntraHarryPotter

self assert: (hogwarts aQueCasaLeCorrespondeIr: harryPotter ) equals: gryffindor.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 16:13'!
testPreguntarSiDracoEntraEnSlytherin

(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.

self assert: (slytherin estaAca: draco).! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 15:58'!
testPreguntarSiHarryNoEntraEnSlytherin

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.

self deny: (slytherin estaAca: harryPotter).! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 16:23'!
testRonPuedeSeguirADraco

(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.

self assert: (ron puedoSeguirA: draco).! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 16:11'!
testRonPuedeSeguirAHarry

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.

self assert: (ron puedoSeguirA: harryPotter).! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 16:29'!
testRonSigueADraco

(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.
ron seguirA: draco.

self assert: (hogwarts cuantosSiguenA: draco) equals: 1.
self assert: (ron seguisA: draco).! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 16:17'!
testRonSigueAHarry

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.
ron seguirA: harryPotter.

self assert: (hogwarts cuantosSiguenA: harryPotter) equals: 1.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 16:28'!
testRonSigueAHarryYADracoPeroDracoInsultaAHarry

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.
(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.
ron seguirA: harryPotter.
ron seguirA: draco.
harryPotter esInsultadoPor: draco.

self assert: (hogwarts cuantosSiguenA: harryPotter) equals: 1.
self assert: (hogwarts cuantosSiguenA: draco) equals: 0.
self deny: (ron seguisA: draco).! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 16:21'!
testRonSigueAHarryYHarryInsultaARon

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.
ron seguirA: harryPotter.
ron esInsultadoPor: harryPotter.

self assert: (hogwarts cuantosSiguenA: harryPotter) equals: 0.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 12:27'!
testSaberCuantosSiguenARon

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.

self assert: (hogwarts cuantosSiguenA: ron) equals: 0.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:27'!
testSaberQueCasaTieneMasMagos

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.
(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.

self assert: (hogwarts queCasaTieneMasMagos) equals: gryffindor .! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 01:01'!
testSaberSiHarryPotterEstaEnLaMismaCasaQueDraco

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.

self deny: (hogwarts esta: harryPotter enLaMismaCasaQue: draco).! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 16:13'!
testSaberSiHarryPotterEstaEnLaMismaCasaQueRon

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.

self assert: (hogwarts esta: harryPotter enLaMismaCasaQue: ron).! !

Object subclass: #Casa
	instanceVariableNames: 'magos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Casa methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/16/2014 00:51'!
agregarMago: unMago
magos add: unMago.! !

!Casa methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:32'!
cantidadDeMagos
^magos size.! !

!Casa methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 16:10'!
cuantosSiguenA: unMago

^(self quienesSiguenA: unMago) size.! !

!Casa methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:32'!
estaAca: unMago
^magos includes: unMago.! !

!Casa methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 15:51'!
hacerQueSeguidoresDe: unMago seanEnemigosDe: otroMago
(self quienesSiguenA: unMago) do: [ :mago | mago agregarEnemigo: otroMago ]! !

!Casa methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:32'!
inicializar
magos := Set new.! !

!Casa methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 15:35'!
quienesSiguenA: unMago
| coleccionQuienesSiguenAUnMago |
^coleccionQuienesSiguenAUnMago := (magos select: [:mago | mago seguisA: unMago]).
! !

Casa subclass: #Gryffindor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Gryffindor methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 10:22'!
aceptaA: unMago
^(unMago esPelirrojo | unMago inteligenciaPromedio).! !

Casa subclass: #Hufflepuff
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Hufflepuff methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 22:55'!
aceptaA: unMago
^true.! !

Casa subclass: #Ravenclaw
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Ravenclaw methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 18:40'!
aceptaA: unMago
^(unMago muyInteligente).! !

Casa subclass: #Slytherin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Slytherin methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/7/2014 00:43'!
aceptaA: unMago
^(unMago sangreSucia) not! !

Object subclass: #Escuela
	instanceVariableNames: 'casas sombreroSeleccionador'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Escuela methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/16/2014 02:05'!
aQueCasaLeCorrespondeIr: unMago
^sombreroSeleccionador casaQueCorrespondeA: unMago deEstasCasas:  casas.! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:56'!
agregarCasa: unaCasa
casas add: unaCasa.! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 12:24'!
cuantosSiguenA: unMago
^(casas sum:[:casa | casa cuantosSiguenA: unMago]).
! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 15:50'!
elMago: unMago fueInsultadoPor: otroMago
casas do: [ :casa |  casa hacerQueSeguidoresDe: unMago seanEnemigosDe: otroMago ]! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 10:54'!
esta: unMago enLaMismaCasaQue: otroMago
^((casas detect:[:casa | (casa estaAca: unMago)] ) estaAca: otroMago).! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:30'!
inicializar 
casas := OrderedCollection  new.! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 10:59'!
queCasaTieneMasMagos
^casas detectMax:[:casa | casa cantidadDeMagos ].! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 19:09'!
sombreroSeleccionador
^sombreroSeleccionador.! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 19:09'!
sombreroSeleccionador: sombrero
sombreroSeleccionador := sombrero.! !

Object subclass: #Hechizo
	instanceVariableNames: 'nombre tipo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

Hechizo subclass: #AvadaKedavra
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!AvadaKedavra methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:43'!
atacar: emisor a: receptor
emisor vida: ((emisor vida)-((receptor vida) /2)).
receptor vida:0.
emisor moral: 'mortifago'.
emisor curaciones: 0.! !

Hechizo subclass: #Combate
	instanceVariableNames: 'energia coeficiente'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Combate methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:43'!
atacar: emisor a: receptor
emisor energia: (emisor energia)-(self energia).
receptor vida: (receptor vida) - (5*(self coeficiente) + emisor poderVarita).
(receptor murio) ifTrue:[emisor moral:'mortifago'. emisor curaciones: 0.].! !

!Combate methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:06'!
coeficiente
^coeficiente.! !

!Combate methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:07'!
coeficiente: valor
coeficiente:=valor.! !

!Combate methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:00'!
energia
^energia.! !

!Combate methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 17:59'!
energia: valor
energia:=valor.! !

Hechizo subclass: #Expelliarmus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Expelliarmus methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:16'!
atacar: emisor a: receptor
|poderEmisor|
poderEmisor:= emisor poderVarita.
(receptor poderVarita > emisor poderVarita) ifTrue:[emisor poderVarita: receptor poderVarita. receptor  poderVarita:poderEmisor].! !

!Hechizo methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 19:47'!
nombre
^nombre.! !

!Hechizo methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 19:47'!
nombre: valor
nombre:=valor.! !

!Hechizo methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:32'!
tipo
^tipo.
! !

!Hechizo methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:31'!
tipo:valor
tipo:=valor.
! !

Hechizo subclass: #Imperdonable
	instanceVariableNames: 'coeficiente'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Imperdonable methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:42'!
atacar: emisor a: receptor
|valor|
valor:=(self coeficiente)- 4* (emisor losQueSigo size).
emisor vida: (emisor vida) - valor.
receptor vida: (receptor vida) - 2*valor.
(receptor murio) ifTrue:[emisor moral:'mortifago'. emisor curaciones: 0.].! !

!Imperdonable methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:08'!
coeficiente
^coeficiente.! !

!Imperdonable methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:08'!
coeficiente: valor
coeficiente:=valor.! !

Hechizo subclass: #Sanador
	instanceVariableNames: 'energia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Sanador methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:45'!
atacar: emisor a: receptor
emisor energia: (emisor energia)-(self energia).
(receptor murio not) ifTrue:[receptor energia: (receptor energia) + (2*(self energia))]. 
emisor curaciones: (emisor curaciones) +1.
(emisor curaciones >= 4) ifTrue:[emisor moral:'auror'].! !

!Sanador methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 17:56'!
energia
^energia.! !

!Sanador methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 17:56'!
energia: valor
energia:=valor.! !

Object subclass: #Mago
	instanceVariableNames: 'colorPelo inteligencia sangreSucia enemigos padre escuela losQueSigo vida energia poderVarita hechizosQueSe moral curaciones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:13'!
agregarAQuienSigo: unMago
losQueSigo add: unMago.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 02:05'!
agregarEnemigo:unMago
enemigos add: unMago.
(self seguisA: unMago) ifTrue: [ losQueSigo remove: unMago ].! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 17:32'!
aprenderHechizo: hechizo
(self puedoAprender: hechizo) ifTrue: [hechizosQueSe add: hechizo].! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:49'!
atacarA: receptor con: hechizo
(hechizosQueSe includes: hechizo) ifTrue:[(hechizo tipo) atacar: self a: receptor].! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:01'!
colorPelo
^colorPelo! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:01'!
colorPelo: color
colorPelo := color! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:29'!
curaciones
^curaciones.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:29'!
curaciones: valor
curaciones:=valor.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 16:49'!
energia
^energia.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 16:49'!
energia: valor
energia:=valor.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:46'!
esEnemigoDe: unMago
^(enemigos includes: unMago).! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 23:47'!
esHermanoDe: unMago
^( (padre = unMago miPadreEs) & (self ~= unMago) ).! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 15:52'!
esInsultadoPor: unMago
self agregarEnemigo: unMago.
escuela elMago: self fueInsultadoPor: unMago.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 18:39'!
esPelirrojo
^self colorPelo = 'rojo'! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:57'!
escuela
^escuela.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:56'!
escuela: unaEscuela
escuela:=unaEscuela.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:30'!
inicializarCuraciones
self curaciones =0.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 23:31'!
inicializarEnemigos
enemigos := Set new.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 17:43'!
inicializarHechizosQueSe
hechizosQueSe  := Set new.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:12'!
inicializarLosQueSigo
losQueSigo := Set new.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:30'!
inicializarMoral
self moral: 'neutro'.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/27/2014 15:29'!
initialize
self vida: 1000.
self energia: 1000.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:09'!
inteligencia
^inteligencia! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:04'!
inteligencia: numero
inteligencia := numero! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/7/2014 00:40'!
inteligenciaPromedio
^(self inteligencia >80) & (self inteligencia <120)! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 23:43'!
miPadreEs 
^padre.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:49'!
miPadreEs: valor
padre := valor.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:21'!
moral
^moral.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:21'!
moral: valor
moral:=valor.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:26'!
murio
^(0>=self vida).! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/6/2014 00:40'!
muyInteligente
^(self inteligencia) >= 120! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 17:12'!
poderVarita
^poderVarita. ! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 17:13'!
poderVarita:valor
poderVarita:=valor. ! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 19:46'!
puedoAprender: hechizo 
((hechizo tipo)=='sanador' &  (self losQueSigo size)>0) ifTrue:[self aprenderHechizo: hechizo]
ifFalse:[ self aprenderHechizo: hechizo ].! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/20/2014 13:35'!
puedoSeguirA: unMago

|coleccionDeCondiciones con1 con2 con3|

con1 := [:mago |  (self esEnemigoDe: mago) not ].
con2 := [:mago | (self esHermanoDe: mago) | (mago inteligencia > self inteligencia | ((escuela cuantosSiguenA: mago) > 3))  ].
con3 := [:mago | self ~= mago ].

coleccionDeCondiciones := Set new.
coleccionDeCondiciones add: con1.
coleccionDeCondiciones add: con2.
coleccionDeCondiciones add: con3.

^coleccionDeCondiciones allSatisfy:[:condicion | condicion value: unMago].

"^(
	((self esEnemigoDe: unMago) not) & 
	( 
		(self esHermanoDe: unMago) | 
		( 
			unMago inteligencia > self inteligencia | 
			((escuela cuantosSiguenA: unMago) > 3)
		) 
	) &
	(self ~= unMago
	)
)."








! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/7/2014 03:31'!
recibeHechizoDe: unMago
self agregarEnemigo: unMago.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:28'!
recibirPerdon
self moral: 'neutro'.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:22'!
sangreSucia
^sangreSucia! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:12'!
sangreSucia: valor
sangreSucia := valor! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:42'!
seguirA: unMago
(self puedoSeguirA: unMago) ifTrue:[losQueSigo add: unMago].! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:11'!
seguisA: unMago
^(losQueSigo includes: unMago).! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 16:48'!
vida
^vida.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 16:48'!
vida: valor
vida:=valor.! !

Object subclass: #Sombrero
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Sombrero methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/16/2014 02:04'!
asignarCasaA: unMago deEstasCasas: lasCasas 
(self casaQueCorrespondeA: unMago) agregarMago: unMago.
! !

!Sombrero methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/16/2014 02:03'!
casaQueCorrespondeA: unMago deEstasCasas: lasCasas 
^lasCasas detect: [ :unaCasa | unaCasa aceptaA: unMago].! !
